package net.minecraft.client;

import net.minecraft.client.player.MovementInputFromOptions;
import java.io.Reader;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import net.minecraft.client.gui.GuiLoading;
import net.minecraft.game.level.generator.LevelGenerator;
import net.minecraft.client.inventory.IInventory;
import net.minecraft.client.gui.GuiInventory;
import net.minecraft.client.gui.GuiInventoryCreative;
import net.minecraft.game.entity.player.InventoryPlayer;
import net.minecraft.game.item.ItemStack;
import net.minecraft.game.block.Block;
import net.minecraft.game.entity.Entity;
import net.minecraft.game.item.Item;
import net.minecraft.client.player.PlayerControllerCreative;
import net.minecraft.game.entity.player.EntityPlayer;
import net.minecraft.client.gui.GuiIngameMenu;
import org.lwjgl.input.Cursor;
import java.nio.IntBuffer;
import org.lwjgl.opengl.ContextCapabilities;
import net.minecraft.client.renderer.WorldRenderer;
import net.minecraft.game.entity.EntityLiving;
import javax.swing.JOptionPane;
import org.lwjgl.BufferUtils;
import net.minecraft.client.renderer.block.TextureGearsFX;
import net.minecraft.client.renderer.block.TextureFlamesFX;
import net.minecraft.client.renderer.block.TextureWaterFlowFX;
import net.minecraft.client.renderer.block.TextureFX;
import org.lwjgl.input.Controllers;
import java.awt.Component;
import org.lwjgl.LWJGLException;
import java.nio.ByteOrder;
import java.nio.ByteBuffer;
import org.lwjgl.opengl.GLContext;
import org.lwjgl.opengl.GL11;
import org.lwjgl.Sys;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.Display;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.gui.GuiGameOver;
import net.minecraft.client.gui.GuiMainMenu;
import net.minecraft.client.gui.GuiErrorScreen;
import net.minecraft.client.model.ModelBiped;
import net.minecraft.client.player.PlayerControllerSurvival;
import net.minecraft.client.renderer.block.TextureLavaFX;
import net.minecraft.client.renderer.block.TextureWaterFX;
import java.io.File;
import net.minecraft.client.sound.SoundManager;
import net.minecraft.client.physics.MovingObjectPosition;
import net.minecraft.client.gui.GuiIngame;
import net.minecraft.client.renderer.EntityRenderer;
import net.minecraft.client.gui.GuiLevelLoading;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.renderer.RenderEngine;
import java.awt.Canvas;
import net.minecraft.client.particle.EffectRenderer;
import net.minecraft.client.player.EntityPlayerSP;
import net.minecraft.client.renderer.RenderGlobal;
import net.minecraft.game.level.World;
import net.minecraft.client.player.PlayerController;

public final class Minecraft implements Runnable {
    public PlayerController playerController;
    private boolean fullscreen;
    public int displayWidth;
    public int displayHeight;
    private Blank blank;
    private Timer timer;
    public World theWorld;
    public RenderGlobal renderGlobal;
    public EntityPlayerSP thePlayer;
    public EffectRenderer effectRenderer;
    public SessionData session;
    public String minecraftUri;
    public Canvas mcCanvas;
    public boolean hideQuitButton;
    public volatile boolean isGamePaused;
    public RenderEngine renderEngine;
    public FontRenderer fontRenderer;
    public GuiScreen currentScreen;
    public GuiLevelLoading loadingScreen;
    public EntityRenderer entityRenderer;
    private ThreadDownloadResources downloadResourcesThread;
    private int ticksRan;
    private int leftClickCounter;
    private int tempDisplayWidth;
    private int tempDisplayHeight;
    public String objectMouseOverString;
    public int rightClickDelayTimer;
    public GuiIngame ingameGUI;
    public boolean online;
    public MovingObjectPosition objectMouseOver;
    public GameSettings gameSettings;
    private MinecraftApplet mcApplet;
    public SoundManager sndManager;
    public MouseHelper mouseHelper;
    public File mcDataDir;
    private String server;
    private TextureWaterFX textureWaterFX;
    private TextureLavaFX textureLavaFX;
    public volatile boolean running;
    public String debug;
    public boolean inventoryScreen;
    private int prevFrameTime;
    public boolean inGameHasFocus;
    
    public Minecraft(final Canvas canvas, final MinecraftApplet minecraftApplet, final int tempDisplayWidth, final int tempDisplayHeight, final boolean fullscreen) {
        this.playerController = new PlayerControllerSurvival(this);
        this.fullscreen = false;
        this.timer = new Timer(20.0f);
        this.session = null;
        this.hideQuitButton = true;
        this.isGamePaused = false;
        this.currentScreen = null;
        this.loadingScreen = new GuiLevelLoading(this);
        this.entityRenderer = new EntityRenderer(this);
        this.ticksRan = 0;
        this.leftClickCounter = 0;
        this.objectMouseOverString = null;
        this.rightClickDelayTimer = 0;
        this.online = false;
        new ModelBiped(0.0f);
        this.objectMouseOver = null;
        this.sndManager = new SoundManager();
        this.server = null;
        this.textureWaterFX = new TextureWaterFX();
        this.textureLavaFX = new TextureLavaFX();
        this.running = false;
        this.debug = "";
        this.inventoryScreen = false;
        this.prevFrameTime = 0;
        this.inGameHasFocus = false;
        this.tempDisplayWidth = tempDisplayWidth;
        this.tempDisplayHeight = tempDisplayHeight;
        this.fullscreen = fullscreen;
        this.mcApplet = minecraftApplet;
        new ThreadSleepForever(this, "Timer hack thread");
        this.mcCanvas = canvas;
        this.displayWidth = tempDisplayWidth;
        this.displayHeight = tempDisplayHeight;
        this.fullscreen = fullscreen;
        theMinecraft = this;
    }
    
    public final void setServer(final String string, final int integer) {
        this.server = string;
    }
    
    public final void displayGuiScreen(GuiScreen var_1_2B) {
        if (this.currentScreen instanceof GuiErrorScreen) {
            return;
        }
        if (this.currentScreen != null) {
            this.currentScreen.onGuiClosed();
        }
        if (var_1_2B == null && this.theWorld == null) {
            var_1_2B = new GuiMainMenu();
        }
        else if (var_1_2B == null && this.thePlayer.health <= 0) {
            var_1_2B = new GuiGameOver();
        }
        if ((this.currentScreen = var_1_2B) != null) {
            this.inputLock();
            final ScaledResolution scaledResolution = new ScaledResolution(this.displayWidth, this.displayHeight);
            var_1_2B.setWorldAndResolution(this, scaledResolution.getScaledWidth(), scaledResolution.getScaledHeight());
            this.online = false;
            return;
        }
        this.setIngameFocus();
    }
    
    public final void shutdownMinecraftApplet() {
        try {
            if (this.downloadResourcesThread != null) {
                this.downloadResourcesThread.closeMinecraft();
            }
        }
        catch (Exception ex) {}
        try {
            this.sndManager.closeMinecraft();
            Mouse.destroy();
            Keyboard.destroy();
        }
        finally {
            Display.destroy();
        }
    }
    
    public final void run() {
        this.running = true;
        try {
            if (this.mcCanvas != null) {
                Display.setParent(this.mcCanvas);
            }
            else if (this.fullscreen) {
                Display.setFullscreen(true);
                this.displayWidth = Display.getDisplayMode().getWidth();
                this.displayHeight = Display.getDisplayMode().getHeight();
            }
            else {
                Display.setDisplayMode(new DisplayMode(this.displayWidth, this.displayHeight));
            }
            Display.setTitle("Minecraft Minecraft Indev");
            try {
                Display.create();
                System.out.println("LWJGL version: " + Sys.getVersion());
                System.out.println("GL RENDERER: " + GL11.glGetString(7937));
                System.out.println("GL VENDOR: " + GL11.glGetString(7936));
                System.out.println("GL VERSION: " + GL11.glGetString(7938));
                final ContextCapabilities capabilities = GLContext.getCapabilities();
                System.out.println(new StringBuilder().append("OpenGL 3.0: ").append(capabilities.OpenGL30).toString());
                System.out.println(new StringBuilder().append("OpenGL 3.1: ").append(capabilities.OpenGL31).toString());
                System.out.println(new StringBuilder().append("OpenGL 3.2: ").append(capabilities.OpenGL32).toString());
                System.out.println(new StringBuilder().append("ARB_compatibility: ").append(capabilities.GL_ARB_compatibility).toString());
                if (capabilities.OpenGL32) {
                    final IntBuffer intBuffer = ByteBuffer.allocateDirect(64).order(ByteOrder.nativeOrder()).asIntBuffer();
                    GL11.glGetInteger(37158, intBuffer);
                    final int value = intBuffer.get(0);
                    System.out.println("PROFILE MASK: " + Integer.toBinaryString(value));
                    System.out.println(new StringBuilder().append("CORE PROFILE: ").append((value & 0x1) != 0x0).toString());
                    System.out.println(new StringBuilder().append("COMPATIBILITY PROFILE: ").append((value & 0x2) != 0x0).toString());
                }
            }
            catch (LWJGLException ex) {
                ex.printStackTrace();
                try {
                    Thread.sleep(1000L);
                }
                catch (InterruptedException ex7) {}
                Display.create();
            }
            Keyboard.create();
            Mouse.create();
            this.mouseHelper = new MouseHelper((Component)this.mcCanvas);
            try {
                Controllers.create();
            }
            catch (Exception ex2) {
                ex2.printStackTrace();
            }
            GL11.glEnable(3553);
            GL11.glShadeModel(7425);
            GL11.glClearDepth(1.0);
            GL11.glEnable(2929);
            GL11.glDepthFunc(515);
            GL11.glEnable(3008);
            GL11.glAlphaFunc(516, 0.1f);
            GL11.glCullFace(1029);
            GL11.glMatrixMode(5889);
            GL11.glLoadIdentity();
            GL11.glMatrixMode(5888);
            this.blank = new Blank();
            final String s = "minecraft";
            final String property = System.getProperty("user.home", ".");
            final String lowerCase;
            File mcDataDir = new File(".");
//            switch (OSValidator.osValues[((lowerCase = System.getProperty("os.name").toLowerCase()).contains("win") ? OS.windows : (lowerCase.contains("mac") ? OS.macos : (lowerCase.contains("solaris") ? OS.solaris : (lowerCase.contains("sunos") ? OS.solaris : (lowerCase.contains("linux") ? OS.linux : (lowerCase.contains("unix") ? OS.linux : OS.unknown)))))).ordinal()]) {
//                case 1:
//                case 2: {
//                    mcDataDir = new File(property, '.' + s + '/');
//                    break;
//                }
//                case 3: {
//                    final String getenv;
//                    if ((getenv = System.getenv("APPDATA")) != null) {
//                        mcDataDir = new File(getenv, "." + s + '/');
//                        break;
//                    }
//                    mcDataDir = new File(property, '.' + s + '/');
//                    break;
//                }
//                case 4: {
//                    mcDataDir = new File(property, "Library/Application Support/" + s);
//                    break;
//                }
//                default: {
//                    mcDataDir = new File(property, s + '/');
//                    break;
//                }
//            }
            if (!mcDataDir.exists() && !mcDataDir.mkdirs()) {
                throw new RuntimeException(new StringBuilder().append("The working directory could not be created: ").append(mcDataDir).toString());
            }
            this.mcDataDir = mcDataDir;
            this.gameSettings = new GameSettings(this, this.mcDataDir);
            this.sndManager.loadSoundSettings(this.gameSettings);
            (this.renderEngine = new RenderEngine(this.gameSettings)).registerTextureFX(this.textureLavaFX);
            this.renderEngine.registerTextureFX(this.textureWaterFX);
            this.renderEngine.registerTextureFX(new TextureWaterFlowFX());
            this.renderEngine.registerTextureFX(new TextureFlamesFX(0));
            this.renderEngine.registerTextureFX(new TextureFlamesFX(1));
            this.renderEngine.registerTextureFX(new TextureGearsFX(0));
            this.renderEngine.registerTextureFX(new TextureGearsFX(1));
            this.fontRenderer = new FontRenderer(this.gameSettings, "/default.png", this.renderEngine);
            BufferUtils.createIntBuffer(256).clear().limit(256);
            this.renderGlobal = new RenderGlobal(this, this.renderEngine);
            GL11.glViewport(0, 0, this.displayWidth, this.displayHeight);
            if (this.server != null && this.session != null) {
                final World level;
                (level = new World()).generate(8, 8, 8, new byte[512], new byte[512]);
                this.setLevel(level);
            }
            else if (this.theWorld == null) {
                this.displayGuiScreen(new GuiMainMenu());
            }
            this.effectRenderer = new EffectRenderer(this.theWorld, this.renderEngine);
            try {
                (this.downloadResourcesThread = new ThreadDownloadResources(this.mcDataDir, this)).start();
            }
            catch (Exception ex8) {}
            this.ingameGUI = new GuiIngame(this);
        }
        catch (Exception ex4) {
            final Exception ex3 = ex4;
            ex4.printStackTrace();
            JOptionPane.showMessageDialog((Component)null, ex3.toString(), "Failed to start Minecraft", 0);
            return;
        }
        long currentTimeMillis = System.currentTimeMillis();
        int n = 0;
        try {
            while (this.running) {
                if (this.theWorld != null) {
                    this.theWorld.tickEntities();
                }
                if (this.mcCanvas == null && Display.isCloseRequested()) {
                    this.running = false;
                }
                try {
                    if (this.isGamePaused) {
                        final double renderPartialTicks = this.timer.renderPartialTicks;
                        this.timer.updateTimer();
                        this.timer.renderPartialTicks = renderPartialTicks;
                    }
                    else {
                        this.timer.updateTimer();
                    }
                    for (int i = 0; i < this.timer.elapsedTicks; ++i) {
                        ++this.ticksRan;
                        this.runTick();
                    }
                    this.sndManager.setListener(this.thePlayer, this.timer.renderPartialTicks);
                    GL11.glEnable(3553);
                    this.playerController.setPartialTime(this.timer.renderPartialTicks);
                    this.entityRenderer.updateCameraAndRender(this.timer.renderPartialTicks);
                    if (!Display.isActive()) {
                        if (this.fullscreen) {
                            this.toggleFullscreen();
                        }
                        Thread.sleep(10L);
                    }
                    if (this.mcCanvas != null && !this.fullscreen && (this.mcCanvas.getWidth() != this.displayWidth || this.mcCanvas.getHeight() != this.displayHeight)) {
                        this.displayWidth = this.mcCanvas.getWidth();
                        this.displayHeight = this.mcCanvas.getHeight();
                        this.resize(this.displayWidth, this.displayHeight);
                    }
                    if (this.gameSettings.limitFramerate) {
                        Thread.sleep(5L);
                    }
                    ++n;
                    this.isGamePaused = (this.currentScreen != null && this.currentScreen.doesGuiPauseGame());
                }
                catch (Throwable ex5) {
                    this.displayGuiScreen(new GuiErrorScreen("Client error", new StringBuilder().append("The game broke! [").append(ex5).append("]").toString()));
                    ex5.printStackTrace();
                }
                while (System.currentTimeMillis() >= currentTimeMillis + 1000L) {
                    this.debug = new StringBuilder().append(n).append(" fps, ").append(WorldRenderer.chunksUpdated).append(" chunk updates").toString();
                    WorldRenderer.chunksUpdated = 0;
                    currentTimeMillis += 1000L;
                    n = 0;
                }
            }
        }
        catch (MinecraftError minecraftError) {}
        catch (Exception ex6) {
            ex6.printStackTrace();
        }
        finally {
            this.shutdownMinecraftApplet();
        }
    }
    
    public final void setIngameFocus() {
        if (!Display.isActive()) {
            return;
        }
        if (this.inventoryScreen) {
            return;
        }
        this.inventoryScreen = true;
        this.mouseHelper.grabMouseCursor();
        this.displayGuiScreen(null);
        this.prevFrameTime = this.ticksRan + 10000;
    }
    
    private void inputLock() {
        if (!this.inventoryScreen) {
            return;
        }
        if (this.thePlayer != null) {
            this.thePlayer.movementInput.resetKeyState();
        }
        this.inventoryScreen = false;
        try {
            Mouse.setNativeCursor((Cursor)null);
        }
        catch (LWJGLException ex) {
            ex.printStackTrace();
        }
    }
    
    public final void displayInGameMenu() {
        if (this.currentScreen != null) {
            return;
        }
        this.displayGuiScreen(new GuiIngameMenu());
    }
    
    private void clickMouse(final int clickState) {
        if (clickState == 0 && this.leftClickCounter > 0) {
            return;
        }
        if (clickState == 0) {
            this.entityRenderer.itemRenderer.equippedItemRender();
        }
        final ItemStack currentItem;
        if (clickState == 1 && (currentItem = this.thePlayer.inventory.getCurrentItem()) != null) {
            final int n = currentItem.stackSize;
            final ItemStack itemStack = currentItem;
            final ItemStack onItemRightClick;
            if ((onItemRightClick = itemStack.getItem().onItemRightClick(itemStack, this.theWorld, this.thePlayer)) != currentItem || (onItemRightClick != null && onItemRightClick.stackSize != n)) {
                this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = onItemRightClick;
                this.entityRenderer.itemRenderer.resetEquippedProgress();
                if (onItemRightClick.stackSize == 0) {
                    this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = null;
                }
            }
        }
        if (this.objectMouseOver == null) {
            if (clickState == 0 && !(this.playerController instanceof PlayerControllerCreative)) {
                this.leftClickCounter = 10;
            }
            return;
        }
        if (this.objectMouseOver.typeOfHit == 1) {
            if (clickState == 0) {
                final EntityPlayerSP thePlayer = this.thePlayer;
                final Entity entityHit = this.objectMouseOver.entityHit;
                final EntityPlayerSP entity = thePlayer;
                final InventoryPlayer inventory = thePlayer.inventory;
                final ItemStack stackInSlot;
                final int n2;
                if ((n2 = (((stackInSlot = inventory.getStackInSlot(inventory.currentItem)) != null) ? Item.itemsList[stackInSlot.itemID].getDamageVsEntity() : 1)) > 0) {
                    entityHit.attackEntityFrom(entity, n2);
                    final ItemStack currentItem2;
                    if ((currentItem2 = entity.inventory.getCurrentItem()) != null && entityHit instanceof EntityLiving) {
                        final ItemStack itemStack2 = currentItem2;
                        final EntityLiving entityLiving = (EntityLiving)entityHit;
                        final ItemStack itemStack3 = itemStack2;
                        Item.itemsList[itemStack3.itemID].hitEntity(itemStack3);
                        if (currentItem2.stackSize <= 0) {
                            entity.displayGUIInventory();
                        }
                    }
                }
            }
        }
        else if (this.objectMouseOver.typeOfHit == 0) {
        	long blockX = this.objectMouseOver.blockX;
            long n = this.objectMouseOver.blockY;
            final long blockZ = this.objectMouseOver.blockZ;
            final int sideHit = this.objectMouseOver.sideHit;
            final Block block = Block.blocksList[this.theWorld.getBlockId(blockX, n, blockZ)];
            if (clickState == 0) {
                this.theWorld.extinguishFire(blockX, n, blockZ, this.objectMouseOver.sideHit);
                if (block != Block.bedrock) {
                    this.playerController.clickBlock(blockX, n, blockZ);
                }
            }
            else {
                final ItemStack currentItem3 = this.thePlayer.inventory.getCurrentItem();
                int n3;
                if ((n3 = this.theWorld.getBlockId(blockX, n, blockZ)) > 0 && Block.blocksList[n3].blockActivated(this.theWorld, blockX, n, blockZ, this.thePlayer)) {
                    return;
                }
                if (currentItem3 == null) {
                    return;
                }
                n3 = currentItem3.stackSize;
                final ItemStack itemStack4 = currentItem3;
                final World theWorld = this.theWorld;
                final long n4 = blockX;
                final long n5 = n;
                final long n6 = blockZ;
                final int integer6 = sideHit;
                n = n6;
                blockX = n5;
                final long n2 = n4;
                if (itemStack4.getItem().onItemUse(itemStack4, theWorld, n2, blockX, n, integer6)) {
                    this.entityRenderer.itemRenderer.equippedItemRender();
                }
                if (currentItem3.stackSize == 0) {
                    this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = null;
                    return;
                }
                if (currentItem3.stackSize != n3) {
                    this.entityRenderer.itemRenderer.equipAnimationSpeed();
                }
            }
        }
    }
    
    public final void toggleFullscreen() {
        try {
            this.fullscreen = !this.fullscreen;
            System.out.println("Toggle fullscreen!");
            if (this.fullscreen) {
                Display.setDisplayMode(Display.getDesktopDisplayMode());
                this.displayWidth = Display.getDisplayMode().getWidth();
                this.displayHeight = Display.getDisplayMode().getHeight();
            }
            else {
                if (this.mcCanvas != null) {
                    this.displayWidth = this.mcCanvas.getWidth();
                    this.displayHeight = this.mcCanvas.getHeight();
                }
                else {
                    this.displayWidth = this.tempDisplayWidth;
                    this.displayHeight = this.tempDisplayHeight;
                }
                Display.setDisplayMode(new DisplayMode(this.tempDisplayWidth, this.tempDisplayHeight));
            }
            this.inputLock();
            Display.setFullscreen(this.fullscreen);
            Display.update();
            Thread.sleep(1000L);
            if (this.fullscreen) {
                this.setIngameFocus();
            }
            if (this.currentScreen != null) {
                this.inputLock();
                this.resize(this.displayWidth, this.displayHeight);
            }
            System.out.println(new StringBuilder().append("Size: ").append(this.displayWidth).append(", ").append(this.displayHeight).toString());
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private void resize(int scaledWidth, int scaledHeight) {
        this.displayWidth = scaledWidth;
        this.displayHeight = scaledHeight;
        if (this.currentScreen != null) {
            final ScaledResolution scaledResolution;
            scaledHeight = (scaledResolution = new ScaledResolution(scaledWidth, scaledHeight)).getScaledWidth();
            scaledWidth = scaledResolution.getScaledHeight();
            this.currentScreen.setWorldAndResolution(this, scaledHeight, scaledWidth);
        }
    }
    
    private void runTick() {
        this.ingameGUI.addChatMessage();
        if (!this.isGamePaused && this.theWorld != null) {
            this.playerController.updateController();
        }
        GL11.glBindTexture(3553, this.renderEngine.getTexture("/terrain.png"));
        if (!this.isGamePaused) {
            this.renderEngine.updateDynamicTextures();
        }
        if (this.currentScreen == null && this.thePlayer != null && this.thePlayer.health <= 0) {
            this.displayGuiScreen(null);
        }
        if (this.currentScreen == null || this.currentScreen.allowUserInput) {
            while (Mouse.next()) {
                final int i;
                if ((i = Mouse.getEventDWheel()) != 0) {
                    final InventoryPlayer inventory = this.thePlayer.inventory;
                    int n = i;
                    final InventoryPlayer inventoryPlayer = inventory;
                    if (n > 0) {
                        n = 1;
                    }
                    if (n < 0) {
                        n = -1;
                    }
                    final InventoryPlayer inventoryPlayer2 = inventoryPlayer;
                    inventoryPlayer2.currentItem -= n;
                    while (inventoryPlayer.currentItem < 0) {
                        final InventoryPlayer inventoryPlayer3 = inventoryPlayer;
                        inventoryPlayer3.currentItem += 9;
                    }
                    while (inventoryPlayer.currentItem >= 9) {
                        final InventoryPlayer inventoryPlayer4 = inventoryPlayer;
                        inventoryPlayer4.currentItem -= 9;
                    }
                }
                if (this.currentScreen == null) {
                    if (!this.inventoryScreen && Mouse.getEventButtonState()) {
                        this.setIngameFocus();
                    }
                    else {
                        if (Mouse.getEventButton() == 0 && Mouse.getEventButtonState()) {
                            this.clickMouse(0);
                            this.prevFrameTime = this.ticksRan;
                        }
                        if (Mouse.getEventButton() == 1 && Mouse.getEventButtonState()) {
                            this.clickMouse(1);
                            this.prevFrameTime = this.ticksRan;
                        }
                        if (Mouse.getEventButton() != 2 || !Mouse.getEventButtonState()) {
                            continue;
                        }
                        if (this.objectMouseOver == null) {
                            continue;
                        }
                        int n;
                        if ((n = this.theWorld.getBlockId(this.objectMouseOver.blockX, this.objectMouseOver.blockY, this.objectMouseOver.blockZ)) == Block.grass.blockID) {
                            n = Block.dirt.blockID;
                        }
                        if (n == Block.stairDouble.blockID) {
                            n = Block.stairSingle.blockID;
                        }
                        if (n == Block.bedrock.blockID) {
                            n = Block.stone.blockID;
                        }
                        this.thePlayer.inventory.getFirstEmptyStack(n);
                    }
                }
                else {
                    if (this.currentScreen == null) {
                        continue;
                    }
                    this.currentScreen.handleMouseInput();
                }
            }
            if (this.leftClickCounter > 0) {
                --this.leftClickCounter;
            }
            while (Keyboard.next()) {
                final EntityPlayerSP thePlayer = this.thePlayer;
                final int eventKey = Keyboard.getEventKey();
                final boolean eventKeyState = Keyboard.getEventKeyState();
                final int n = eventKey;
                thePlayer.movementInput.checkKeyForMovementInput(n, eventKeyState);
                if (Keyboard.getEventKeyState()) {
                    if (Keyboard.getEventKey() == 87) {
                        this.toggleFullscreen();
                    }
                    else {
                        if (this.currentScreen != null) {
                            this.currentScreen.handleKeyboardInput();
                        }
                        else {
                            if (Keyboard.getEventKey() == 1) {
                                this.displayInGameMenu();
                            }
                            if (Keyboard.getEventKey() == 65) {
                                this.entityRenderer.grabLargeScreenshot();
                            }
                            if (this.playerController instanceof PlayerControllerCreative) {
                                if (Keyboard.getEventKey() == this.gameSettings.keyBindLoad.keyCode) {
                                    this.thePlayer.preparePlayerToSpawn();
                                }
                                if (Keyboard.getEventKey() == this.gameSettings.keyBindSave.keyCode) {
                                    this.theWorld.setSpawnPos((int)this.thePlayer.posX, (int)this.thePlayer.posY, (int)this.thePlayer.posZ, this.thePlayer.rotationYaw);
                                    this.thePlayer.preparePlayerToSpawn();
                                }
                            }
                            if (Keyboard.getEventKey() == 63) {
                                this.gameSettings.thirdPersonView = !this.gameSettings.thirdPersonView;
                            }
                            if (Keyboard.getEventKey() == this.gameSettings.keyBindInventory.keyCode) {
                                this.displayGuiScreen(new GuiInventoryCreative(this.thePlayer.inventory));
                            }
                            if (Keyboard.getEventKey() == this.gameSettings.keyBindDrop.keyCode) {
                                this.thePlayer.dropPlayerItemWithRandomChoice(this.thePlayer.inventory.decrStackSize(this.thePlayer.inventory.currentItem, 1), false);
                            }
                        }
                        for (int i = 0; i < 9; ++i) {
                            if (Keyboard.getEventKey() == i + 2) {
                                this.thePlayer.inventory.currentItem = i;
                            }
                        }
                        if (Keyboard.getEventKey() != this.gameSettings.keyBindToggleFog.keyCode) {
                            continue;
                        }
                        this.gameSettings.setOptionValue(4, (Keyboard.isKeyDown(42) || Keyboard.isKeyDown(54)) ? -1 : 1);
                    }
                }
            }
            if (this.currentScreen == null) {
                if (Mouse.isButtonDown(0) && this.ticksRan - this.prevFrameTime >= this.timer.ticksPerSecond / 4.0f && this.inventoryScreen) {
                    this.clickMouse(0);
                    this.prevFrameTime = this.ticksRan;
                }
                if (Mouse.isButtonDown(1) && this.ticksRan - this.prevFrameTime >= this.timer.ticksPerSecond / 4.0f && this.inventoryScreen) {
                    this.clickMouse(1);
                    this.prevFrameTime = this.ticksRan;
                }
            }
            final boolean eventKeyState = this.currentScreen == null && Mouse.isButtonDown(0) && this.inventoryScreen;
            if (!this.playerController.isInTestMode && this.leftClickCounter <= 0) {
                if (eventKeyState && this.objectMouseOver != null && this.objectMouseOver.typeOfHit == 0) {
                    final long blockX = this.objectMouseOver.blockX;
                    final long blockY = this.objectMouseOver.blockY;
                    final long blockZ = this.objectMouseOver.blockZ;
                    this.playerController.sendBlockRemoving(blockX, blockY, blockZ, this.objectMouseOver.sideHit);
                    this.effectRenderer.addBlockHitEffects(blockX, blockY, blockZ, this.objectMouseOver.sideHit);
                }
                else {
                    this.playerController.resetBlockRemoving();
                }
            }
        }
        if (this.currentScreen != null) {
            this.prevFrameTime = this.ticksRan + 10000;
        }
        if (this.currentScreen != null) {
            final GuiScreen currentScreen = this.currentScreen;
            while (Mouse.next()) {
                currentScreen.handleMouseInput();
            }
            while (Keyboard.next()) {
                currentScreen.handleKeyboardInput();
            }
            if (this.currentScreen != null) {
                this.currentScreen.updateScreen();
            }
        }
        if (this.theWorld != null) {
            this.theWorld.difficultySetting = this.gameSettings.difficulty;
            if (!this.isGamePaused) {
                this.entityRenderer.updateRenderer();
            }
            if (!this.isGamePaused) {
                this.renderGlobal.updateClouds();
            }
            if (!this.isGamePaused) {
                this.theWorld.levelEntities();
            }
            if (!this.isGamePaused) {
                this.theWorld.restartTimeOfDay();
            }
            if (!this.isGamePaused) {
                this.theWorld.randomDisplayUpdates((int)this.thePlayer.posX, (int)this.thePlayer.posY, (int)this.thePlayer.posZ);
            }
            if (!this.isGamePaused) {
                this.effectRenderer.updateEffects();
            }
        }
    }
    
    public final void generateLevel(int width, final int worldShape, int depth, int height) {
        this.setLevel(null);
        System.gc();
        //Commented code is original and commented out for anti-piracy patch
        //final String authorName = (this.session != null) ? this.session.username : "anonymous";
        final String authorName = (this.session == null) ? this.session.username : "anonymous";
        final LevelGenerator levelGenerator;
        //(levelGenerator = new LevelGenerator(this.loadingScreen)).islandGen = (depth == 1);
        //levelGenerator.doubleingGen = (depth == 2);
        //levelGenerator.flatGen = (depth == 3);
        //levelGenerator.levelType = height;
        //width = (depth = 128 << width);
        //height = 64;
        if (worldShape == 1) {
            width /= 2;
            depth <<= 1;
        }
        else if (worldShape == 2) {
            width = (depth = width / 2);
            height = 256;
        }
        World world = new World();
        world.generate(0, 0, 0, null, null);
        this.setLevel(world);
    }
    
    public final void setLevel(final World world) {
        if (this.theWorld != null) {
            this.theWorld.worldMethod();
        }
        try {
        	//Commented code is original and commented out for anti-piracy patch
            //final BufferedReader bufferedReader;
            //Integer.parseInt((bufferedReader = new BufferedReader((Reader)new InputStreamReader(new URL(new StringBuilder().append(this.mcApplet.getDocumentBase()).append("?n=").append(this.session.username).append("&i=").append(this.session.sessionId).toString()).openStream()))).readLine());
            //bufferedReader.close();
            //if (this.mcApplet.getDocumentBase().toString().startsWith("http://www.minecraft.net/") || this.mcApplet.getDocumentBase().toString().startsWith("http://minecraft.net/")) {
        	if (!this.mcApplet.getDocumentBase().toString().startsWith("http://www.minecraft.net/") || !this.mcApplet.getDocumentBase().toString().startsWith("http://minecraft.net/")) {
                this.theWorld = world;
            }
        }
        catch (Throwable t) {}
        if (world != null) {
            world.load();
            this.playerController.onWorldChange(world);
            this.thePlayer = (EntityPlayerSP)world.findSubclassOf(EntityPlayerSP.class);
            world.player = this.thePlayer;
            if (this.thePlayer == null) {
                (this.thePlayer = new EntityPlayerSP(this, world, this.session)).preparePlayerToSpawn();
                if (world != null) {
                    world.entityJoinedWorld(this.thePlayer);
                    world.player = this.thePlayer;
                }
            }
            if (this.thePlayer != null) {
                this.thePlayer.movementInput = new MovementInputFromOptions(this.gameSettings);
                this.playerController.blankPlayerFunction(this.thePlayer);
            }
            if (this.renderGlobal != null) {
                this.renderGlobal.changeWorld(world);
            }
            if (this.effectRenderer != null) {
                this.effectRenderer.clearEffects(world);
            }
            this.textureWaterFX.textureId = 0;
            this.textureLavaFX.textureId = 0;
            final int texture = this.renderEngine.getTexture("/water.png");
            if (world.defaultFluid == Block.waterMoving.blockID) {
                this.textureWaterFX.textureId = texture;
            }
            else {
                this.textureLavaFX.textureId = texture;
            }
        }
        System.gc();
    }
    private static Minecraft theMinecraft;
	public static Minecraft getInstance() {
		// TODO Auto-generated method stub
		return theMinecraft;
	}
}
