package net.minecraft.client;

import net.minecraft.client.player.EntityPlayerSP;
import net.minecraft.game.entity.Entity;
import net.minecraft.game.level.World;
import net.minecraft.client.gui.GuiLoading;
import net.minecraft.game.level.LevelLoader;

public final class PlayerLoader extends LevelLoader {
    private Minecraft mc;
    
    public PlayerLoader(final Minecraft minecraft, final GuiLoading guiLoading) {
        super(guiLoading);
        this.mc = minecraft;
    }
    
    @Override
    protected final Entity loadEntity(final World world, final String playerName) {
        if (playerName.equals("LocalPlayer")) {
            return new EntityPlayerSP(this.mc, world, this.mc.session);
        }
        return super.loadEntity(world, playerName);
    }
}
