package net.minecraft.client;

import java.util.List;
import java.io.OutputStream;
import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.Reader;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.io.File;

public final class ThreadDownloadResources extends Thread {
    private File resourcesFolder;
    private Minecraft mc;
    private boolean closing;
    
    public ThreadDownloadResources(final File file, final Minecraft minecraft) {
        this.closing = false;
        this.mc = minecraft;
        this.setName("Resource download thread");
        this.setDaemon(true);
        this.resourcesFolder = new File(file, "resources/");
        if (!this.resourcesFolder.exists() && !this.resourcesFolder.mkdirs()) {
            throw new RuntimeException(new StringBuilder().append("The working directory could not be created: ").append(this.resourcesFolder).toString());
        }
    }
    
    public final void run() {
        try {
            final ArrayList list = new ArrayList();
            //final URL url = new URL("http://www.minecraft.net/resources/");
            final URL url = new URL("https://betacraft.pl/resources/");
            final BufferedReader bufferedReader = new BufferedReader((Reader)new InputStreamReader(url.openStream()));
            String line;
            while ((line = bufferedReader.readLine()) != null) {
                ((List)list).add(line);
            }
            bufferedReader.close();
            for (int i = 0; i < ((List)list).size(); ++i) {
                final URL url2 = url;
                final String s = (String)((List)list).get(i);
                final URL url3 = url2;
                Label_0334: {
                    try {
                        final String[] split;
                        final String s2 = (split = s.split(","))[0];
                        final int int1 = Integer.parseInt(split[1]);
                        Long.parseLong(split[2]);
                        final File file;
                        if (!(file = new File(this.resourcesFolder, s2)).exists() || file.length() != int1) {
                            file.getParentFile().mkdirs();
                            this.downloadResource(new URL(url3, s2.replaceAll(" ", "%20")), file);
                            if (this.closing) {
                                break Label_0334;
                            }
                        }
                        final Minecraft mc = this.mc;
                        final String s3 = s2;
                        final File file2 = file;
                        final String s4 = s3;
                        final Minecraft minecraft = mc;
                        final int index = s4.indexOf("/");
                        final String substring = s4.substring(0, index);
                        final String substring2 = s4.substring(index + 1);
                        if (substring.equalsIgnoreCase("sound")) {
                            minecraft.sndManager.addSound(substring2, file2);
                        }
                        else if (substring.equalsIgnoreCase("newsound")) {
                            minecraft.sndManager.addSound(substring2, file2);
                        }
                        else if (substring.equalsIgnoreCase("music")) {
                            minecraft.sndManager.addMusic(substring2, file2);
                        }
                    }
                    catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
                if (this.closing) {
                    return;
                }
            }
        }
        catch (IOException ex2) {
            ex2.printStackTrace();
        }
    }
    
    private void downloadResource(final URL url, final File file) throws IOException {
        final byte[] array = new byte[4096];
        final DataInputStream dataInputStream = new DataInputStream(url.openStream());
        final DataOutputStream dataOutputStream = new DataOutputStream((OutputStream)new FileOutputStream(file));
        int read;
        while ((read = dataInputStream.read(array)) >= 0) {
            dataOutputStream.write(array, 0, read);
            if (this.closing) {
                return;
            }
        }
        dataInputStream.close();
        dataOutputStream.close();
    }
    
    public final void closeMinecraft() {
        this.closing = true;
    }
}
