package net.minecraft.client.gui;

import net.minecraft.client.renderer.RenderEngine;
import org.lwjgl.opengl.GL11;
import net.minecraft.client.inventory.IInventory;

public final class GuiChest extends GuiContainer {
    private IInventory upperChestInventory;
    private IInventory lowerChestInventory;
    private int inventoryRows;
    
    public GuiChest(final IInventory upperChestInventory, final IInventory lowerChestInventory) {
        this.inventoryRows = 0;
        this.upperChestInventory = upperChestInventory;
        this.lowerChestInventory = lowerChestInventory;
        this.allowUserInput = false;
        this.inventoryRows = lowerChestInventory.getSizeInventory() / 9;
        this.ySize = 114 + this.inventoryRows * 18;
        final int n = (this.inventoryRows - 4) * 18;
        for (int i = 0; i < this.inventoryRows; ++i) {
            for (int j = 0; j < 9; ++j) {
                this.inventorySlots.add(new Slot(this, lowerChestInventory, j + i * 9, 8 + j * 18, 18 + i * 18));
            }
        }
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 9; ++j) {
                this.inventorySlots.add(new Slot(this, upperChestInventory, j + (i + 1) * 9, 8 + j * 18, 103 + i * 18 + n));
            }
        }
        for (int i = 0; i < 9; ++i) {
            this.inventorySlots.add(new Slot(this, upperChestInventory, i, 8 + i * 18, n + 161));
        }
    }
    
    @Override
    protected final void drawGuiContainerForegroundLayer() {
        this.fontRenderer.drawString(this.lowerChestInventory.getInvName(), 8, 6, 4210752);
        this.fontRenderer.drawString(this.upperChestInventory.getInvName(), 8, this.ySize - 96 + 2, 4210752);
    }
    
    @Override
    protected final void drawGuiContainerBackgroundLayer() {
        int texture = this.mc.renderEngine.getTexture("/gui/container.png");
        GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
        RenderEngine.bindTexture(texture);
        texture = (this.width - this.xSize) / 2;
        final int integer2 = (this.height - this.ySize) / 2;
        this.drawTexturedModalRect(texture, integer2, 0, 0, this.xSize, this.inventoryRows * 18 + 17);
        this.drawTexturedModalRect(texture, integer2 + this.inventoryRows * 18 + 17, 0, 126, this.xSize, 96);
    }
}
