package net.minecraft.client.gui;

import net.minecraft.client.player.EntityPlayerSP;
import net.minecraft.client.inventory.IInventory;
import net.minecraft.client.renderer.RenderEngine;
import net.minecraft.client.renderer.RenderHelper;
import org.lwjgl.opengl.GL11;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.game.item.ItemStack;
import net.minecraft.client.renderer.entity.RenderItem;

public abstract class GuiContainer extends GuiScreen {
    private static RenderItem itemRenderer;
    private ItemStack itemStack;
    protected int xSize;
    protected int ySize;
    protected List inventorySlots;
    
    public GuiContainer() {
        this.itemStack = null;
        this.xSize = 176;
        this.ySize = 166;
        this.inventorySlots = (List)new ArrayList();
    }
    
    @Override
    public void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        final int n = (this.width - this.xSize) / 2;
        final int n2 = (this.height - this.ySize) / 2;
        this.drawGuiContainerBackgroundLayer();
        GL11.glPushMatrix();
        GL11.glRotated(180.0f, 1.0f, 0.0f, 0.0f);
        RenderHelper.enableStandardItemLighting();
        GL11.glPopMatrix();
        GL11.glPushMatrix();
        GL11.glTranslated((double)n, (double)n2, 0.0f);
        GL11.glColor4d(1.0f, 1.0f, 1.0f, 1.0f);
        GL11.glEnable(2977);
        for (int i = 0; i < this.inventorySlots.size(); ++i) {
            final Slot slot2;
            final Slot slot = slot2 = (Slot)this.inventorySlots.get(i);
            final IInventory inventory = slot2.inventory;
            final int slotIndex = slot2.slotIndex;
            final int xPos = slot2.xPos;
            final int yPos = slot2.yPos;
            final ItemStack stackInSlot;
            final int backgroundIconIndex;
            if ((stackInSlot = inventory.getStackInSlot(slotIndex)) == null && (backgroundIconIndex = slot2.getBackgroundIconIndex()) >= 0) {
                GL11.glDisable(2896);
                RenderEngine.bindTexture(this.mc.renderEngine.getTexture("/gui/items.png"));
                this.drawTexturedModalRect(xPos, yPos, backgroundIconIndex % 16 << 4, backgroundIconIndex / 16 << 4, 16, 16);
                GL11.glEnable(2896);
            }
            else {
                GuiContainer.itemRenderer.renderItemIntoGUI(this.mc.renderEngine, stackInSlot, xPos, yPos);
                GuiContainer.itemRenderer.renderItemOverlayIntoGUI(this.fontRenderer, stackInSlot, xPos, yPos);
            }
            if (slot.isAtCursorPos(xSize_lo, ySize_lo)) {
                GL11.glDisable(2896);
                GL11.glDisable(2929);
                final int xPos2 = slot.xPos;
                final int yPos2 = slot.yPos;
                Gui.drawGradientRect(xPos2, yPos2, xPos2 + 16, yPos2 + 16, -2130706433, -2130706433);
                GL11.glEnable(2896);
                GL11.glEnable(2929);
            }
        }
        if (this.itemStack != null) {
            GL11.glTranslated(0.0f, 0.0f, 32.0f);
            GuiContainer.itemRenderer.renderItemIntoGUI(this.mc.renderEngine, this.itemStack, xSize_lo - n - 8, ySize_lo - n2 - 8);
            GuiContainer.itemRenderer.renderItemOverlayIntoGUI(this.fontRenderer, this.itemStack, xSize_lo - n - 8, ySize_lo - n2 - 8);
        }
        GL11.glDisable(2977);
        RenderHelper.disableStandardItemLighting();
        GL11.glDisable(2896);
        GL11.glDisable(2929);
        this.drawGuiContainerForegroundLayer();
        GL11.glEnable(2896);
        GL11.glEnable(2929);
        GL11.glPopMatrix();
    }
    
    protected void drawGuiContainerForegroundLayer() {
    }
    
    protected abstract void drawGuiContainerBackgroundLayer();
    
    @Override
    protected final void drawSlotInventory(final int integer1, final int integer2, final int integer3) {
        Slot slot;
        int i4;
        int i5 = 1;
        if (integer3 == 0 || integer3 == 1) {
            int i6 = 0;
            while (true) {
                if (i6 >= this.inventorySlots.size()) {
                    slot = null;
                    break;
                }
                Slot slot2 = (Slot) this.inventorySlots.get(i6);
                if (slot2.isAtCursorPos(integer1, integer2)) {
                    slot = slot2;
                    break;
                }
                i6++;
            }
            if (slot != null) {
                ItemStack stackInSlot = slot.inventory.getStackInSlot(slot.slotIndex);
                if (stackInSlot != null || this.itemStack != null) {
                    if (stackInSlot != null && this.itemStack == null) {
                        this.itemStack = slot.inventory.decrStackSize(slot.slotIndex, integer3 == 0 ? stackInSlot.stackSize : (stackInSlot.stackSize + 1) / 2);
                        if (stackInSlot.stackSize == 0) {
                            slot.putStack(null);
                        }
                        slot.onPickupFromSlot();
                    } else if (stackInSlot == null && this.itemStack != null && slot.isItemValid(this.itemStack)) {
                        int i7 = integer3 == 0 ? this.itemStack.stackSize : 1;
                        if (i7 > slot.inventory.getInventoryStackLimit()) {
                            i7 = slot.inventory.getInventoryStackLimit();
                        }
                        slot.putStack(this.itemStack.splitStack(i7));
                        if (this.itemStack.stackSize == 0) {
                            this.itemStack = null;
                        }
                    } else if (stackInSlot != null && this.itemStack != null) {
                        if (slot.isItemValid(this.itemStack)) {
                            if (stackInSlot.itemID != this.itemStack.itemID) {
                                if (this.itemStack.stackSize <= slot.inventory.getInventoryStackLimit()) {
                                    slot.putStack(this.itemStack);
                                    this.itemStack = stackInSlot;
                                }
                            } else if (stackInSlot.itemID != this.itemStack.itemID) {
                            } else {
                                if (integer3 == 0) {
                                    int i8 = this.itemStack.stackSize;
                                    if (i8 > slot.inventory.getInventoryStackLimit() - stackInSlot.stackSize) {
                                        i8 = slot.inventory.getInventoryStackLimit() - stackInSlot.stackSize;
                                    }
                                    if (i8 > this.itemStack.getItem().getItemStackLimit() - stackInSlot.stackSize) {
                                        i8 = this.itemStack.getItem().getItemStackLimit() - stackInSlot.stackSize;
                                    }
                                    this.itemStack.splitStack(i8);
                                    if (this.itemStack.stackSize == 0) {
                                        this.itemStack = null;
                                    }
                                    stackInSlot.stackSize = i8 + stackInSlot.stackSize;
                                } else if (integer3 == 1) {
                                    if (1 > slot.inventory.getInventoryStackLimit() - stackInSlot.stackSize) {
                                        i5 = slot.inventory.getInventoryStackLimit() - stackInSlot.stackSize;
                                    }
                                    if (i5 > this.itemStack.getItem().getItemStackLimit() - stackInSlot.stackSize) {
                                        i5 = this.itemStack.getItem().getItemStackLimit() - stackInSlot.stackSize;
                                    }
                                    this.itemStack.splitStack(i5);
                                    if (this.itemStack.stackSize == 0) {
                                        this.itemStack = null;
                                    }
                                    stackInSlot.stackSize += i5;
                                }
                            }
                        } else if (stackInSlot.itemID == this.itemStack.itemID && this.itemStack.getItem().getItemStackLimit() > 1 && (i4 = stackInSlot.stackSize) > 0 && this.itemStack.stackSize + i4 <= this.itemStack.getItem().getItemStackLimit()) {
                            this.itemStack.stackSize += i4;
                            stackInSlot.splitStack(i4);
                            if (stackInSlot.stackSize == 0) {
                                slot.putStack(null);
                            }
                            slot.onPickupFromSlot();
                        }
                    }
                }
            } else if (this.itemStack != null) {
                int i9 = (this.width - this.xSize) / 2;
                int i10 = (this.height - this.ySize) / 2;
                if (integer1 < i9 || integer2 < i10 || integer1 >= i9 + this.xSize || integer2 >= this.xSize + i10) {
                    EntityPlayerSP thePlayer = this.mc.thePlayer;
                    if (integer3 == 0) {
                        thePlayer.dropPlayerItem(this.itemStack);
                        this.itemStack = null;
                    }
                    if (integer3 == 1) {
                        thePlayer.dropPlayerItem(this.itemStack.splitStack(1));
                        if (this.itemStack.stackSize == 0) {
                            this.itemStack = null;
                        }
                    }
                }
            }
        }
    }
    
    @Override
    protected final void keyTyped(final char character, final int integer) {
        if (integer == 1 || integer == this.mc.gameSettings.keyBindInventory.keyCode) {
            this.mc.displayGuiScreen(null);
        }
    }
    
    @Override
    public void onGuiClosed() {
        if (this.itemStack != null) {
            this.mc.thePlayer.dropPlayerItem(this.itemStack);
        }
    }
    
    public void guiCraftingItemsCheck() {
    }
    
    @Override
    public final boolean doesGuiPauseGame() {
        return false;
    }
    
    static {
        GuiContainer.itemRenderer = new RenderItem();
    }
}
