package net.minecraft.client.gui;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Random;

import net.minecraft.game.level.generator.noise.NoiseGeneratorCombined;
import net.minecraft.game.level.generator.noise.NoiseGeneratorOctaves;

public final class GuiIngameMenu extends GuiScreen {
    @Override
    public final void initGui() {
        this.controlList.clear();
        this.controlList.add(new GuiButton(0, this.width / 2 - 100, this.height / 4, "Options..."));
        this.controlList.add(new GuiButton(1, this.width / 2 - 100, this.height / 4 + 24, "Generate new level..."));
        this.controlList.add(new GuiButton(2, this.width / 2 - 100, this.height / 4 + 48, "Save level.."));
        this.controlList.add(new GuiButton(3, this.width / 2 - 100, this.height / 4 + 72, "Load level.."));
//        this.controlList.add(new GuiButton(5, this.width / 2 - 100, this.height / 4 + 96, "Test"));
        this.controlList.add(new GuiButton(4, this.width / 2 - 100, this.height / 4 + 120, "Back to game"));
        if (this.mc.session == null) {
            ((GuiButton)this.controlList.get(2)).enabled = false;
            ((GuiButton)this.controlList.get(3)).enabled = false;
        }
    }
    
    @Override
    protected final void actionPerformed(final GuiButton r) {
        if (r.id == 0) {
            this.mc.displayGuiScreen(new GuiOptions(this, this.mc.gameSettings));
        }
        if (r.id == 1) {
            this.mc.displayGuiScreen(new GuiLevelType(this));
        }
        if (this.mc.session != null) {
            if (r.id == 2) {
                this.mc.displayGuiScreen(new GuiSaveLevelScreen(this));
            }
            if (r.id == 3) {
                this.mc.displayGuiScreen(new GuiLoadLevelScreen(this));
            }
        }
        if (r.id == 4) {
            this.mc.displayGuiScreen(null);
            this.mc.setIngameFocus();
        }
        if(r.id == 5) {
        	GuiLevelLoading loadingScreen = mc.loadingScreen;
        	loadingScreen.setTitle("Sampling...");
        	ByteArrayOutputStream bout = new ByteArrayOutputStream();
        	DataOutputStream out = new DataOutputStream(bout);
        	Random rand = new Random(0);
        	NoiseGeneratorCombined noise1 = new NoiseGeneratorCombined(new NoiseGeneratorOctaves(rand,8),new NoiseGeneratorOctaves(rand,8));
        	NoiseGeneratorCombined noise2 = new NoiseGeneratorCombined(new NoiseGeneratorOctaves(rand,8),new NoiseGeneratorOctaves(rand,8));
        	NoiseGeneratorOctaves noise3 = new NoiseGeneratorOctaves(rand, 6);
        	for(long i = 0 ; i < 2147483648L; i += 64) {
        		loadingScreen.setProgress((int) (i / 21474836L));
				double n2 = noise1.NoiseGenerator((i) * 1.3f, (0) * 2.3f) / 6.0 - 4.0; 
				double n3 = noise2.NoiseGenerator((i) * 1.3f, (0) * 1.3f) / 5.0 + 10.0 - 4.0; 
				if ((noise3.NoiseGenerator(i, 0) / 8.0) > 0.0) {
                    n3 = n2;
                }
				double n5 = Math.max(n2, n3) / 2.0;
				if (n5 < 0.0) {
                    n5 *= 0.8;
                }
				int height = (int) n5;
				try {
					out.writeInt(height);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
        	}
        	try(FileOutputStream fout = new FileOutputStream("samples.bin")) {
        		try {
					fout.write(bout.toByteArray());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
        	} catch (FileNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
        }
    }
    
    @Override
    public final void drawScreen(final int xSize_lo, final int ySize_lo, final double double3) {
        this.drawDefaultBackground();
        Gui.drawCenteredString(this.fontRenderer, "Game menu", this.width / 2, 40, 16777215);
        super.drawScreen(xSize_lo, ySize_lo, double3);
    }
}
