package net.minecraft.client.inventory;

import net.minecraft.client.gui.GuiContainer;
import net.minecraft.game.item.ItemStack;

public final class InventoryCrafting implements IInventory {
    private ItemStack[] stackList;
    private int inventoryWidth;
    private GuiContainer eventHandler;
    
    public InventoryCrafting(final GuiContainer guiContainer, final int integer2, final int integer3) {
        this.inventoryWidth = integer2 * integer3;
        this.stackList = new ItemStack[this.inventoryWidth];
        this.eventHandler = guiContainer;
    }
    
    public final int getSizeInventory() {
        return this.inventoryWidth;
    }
    
    public final ItemStack getStackInSlot(final int integer) {
        return this.stackList[integer];
    }
    
    public final String getInvName() {
        return "Crafting";
    }
    
    public final ItemStack decrStackSize(final int integer1, final int integer2) {
        if (this.stackList[integer1] == null) {
            return null;
        }
        if (this.stackList[integer1].stackSize <= integer2) {
            final ItemStack itemStack = this.stackList[integer1];
            this.stackList[integer1] = null;
            this.eventHandler.guiCraftingItemsCheck();
            return itemStack;
        }
        final ItemStack splitStack = this.stackList[integer1].splitStack(integer2);
        if (this.stackList[integer1].stackSize == 0) {
            this.stackList[integer1] = null;
        }
        this.eventHandler.guiCraftingItemsCheck();
        return splitStack;
    }
    
    public final void setInventorySlotContents(final int integer, final ItemStack itemStack) {
        this.stackList[integer] = itemStack;
        this.eventHandler.guiCraftingItemsCheck();
    }
    
    public final int getInventoryStackLimit() {
        return 64;
    }
}
