package net.minecraft.client.particle;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.game.block.Block;
import net.minecraft.game.level.World;

public final class EntityDiggingFX extends EntityFX {
    public EntityDiggingFX(final World world, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7, final Block x) {
        super(world, double2, double3, double4, double5, double6, double7);
        this.particleTextureIndex = x.blockIndexInTexture;
        this.particleGravity = x.blockParticleGravity;
        final double particleRed = 0.6f;
        this.particleBlue = particleRed;
        this.particleGreen = particleRed;
        this.particleRed = particleRed;
        this.particleScale /= 2.0f;
    }
    
    @Override
    public final int getFXLayer() {
        return 1;
    }
    
    @Override
    public final void renderParticle(final Tessellator tessellator, double double2, final double double3, final double double4, final double double5, final double double6, final double double7) {
        final double n2;
        final double n = (n2 = (this.particleTextureIndex % 16 + this.particleTextureJitterX / 4.0f) / 16.0f) + 0.015609375f;
        final double n4;
        final double n3 = (n4 = (this.particleTextureIndex / 16 + this.particleTextureJitterY / 4.0f) / 16.0f) + 0.015609375f;
        final double n5 = 0.1f * this.particleScale;
        final double n6 = this.prevPosX + (this.posX - this.prevPosX) * double2;
        final double n7 = this.prevPosY + (this.posY - this.prevPosY) * double2;
        final double n8 = this.prevPosZ + (this.posZ - this.prevPosZ) * double2;
        double2 = this.getEntityBrightness(double2);
        tessellator.setColorOpaque_F(double2 * this.particleRed, double2 * this.particleGreen, double2 * this.particleBlue);
        tessellator.addVertexWithUV(n6 - double3 * n5 - double6 * n5, n7 - double4 * n5, n8 - double5 * n5 - double7 * n5, n2, n3);
        tessellator.addVertexWithUV(n6 - double3 * n5 + double6 * n5, n7 + double4 * n5, n8 - double5 * n5 + double7 * n5, n2, n4);
        tessellator.addVertexWithUV(n6 + double3 * n5 + double6 * n5, n7 + double4 * n5, n8 + double5 * n5 + double7 * n5, n, n4);
        tessellator.addVertexWithUV(n6 + double3 * n5 - double6 * n5, n7 - double4 * n5, n8 + double5 * n5 - double7 * n5, n, n3);
    }
}
