package net.minecraft.client.particle;

import net.minecraft.client.renderer.Tessellator;
import net.minecraft.game.level.World;

public final class EntityExplodeFX extends EntityFX {
    public EntityExplodeFX(final World world, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7) {
        super(world, double2, double3, double4, double5, double6, double7);
        this.motionX1 = double5 + (double)(Math.random() * 2.0 - 1.0) * 0.05f;
        this.motionY1 = double6 + (double)(Math.random() * 2.0 - 1.0) * 0.05f;
        this.motionZ1 = double7 + (double)(Math.random() * 2.0 - 1.0) * 0.05f;
        final double particleRed = this.rand.nextDouble() * 0.3f + 0.7f;
        this.particleBlue = particleRed;
        this.particleGreen = particleRed;
        this.particleRed = particleRed;
        this.particleScale = this.rand.nextDouble() * this.rand.nextDouble() * 6.0f + 1.0f;
        this.particleMaxAge = (int)(16.0 / (this.rand.nextDouble() * 0.8 + 0.2)) + 2;
    }
    
    @Override
    public final void renderParticle(final Tessellator tessellator, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7) {
        super.renderParticle(tessellator, double2, double3, double4, double5, double6, double7);
    }
    
    @Override
    public final void onEntityUpdate() {
        this.prevPosX = this.posX;
        this.prevPosY = this.posY;
        this.prevPosZ = this.posZ;
        if (this.particleAge++ >= this.particleMaxAge) {
            this.setEntityDead();
        }
        this.particleTextureIndex = 7 - (this.particleAge << 3) / this.particleMaxAge;
        this.motionY1 += (double)0.004;
        this.moveEntity(this.motionX1, this.motionY1, this.motionZ1);
        this.motionX1 *= 0.9f;
        this.motionY1 *= 0.9f;
        this.motionZ1 *= 0.9f;
        if (this.onGround) {
            this.motionX1 *= 0.7f;
            this.motionZ1 *= 0.7f;
        }
    }
}
