package net.minecraft.client.particle;

import net.minecraft.game.block.Material;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.game.level.World;

public class EntityRainFX extends EntityFX {
    public EntityRainFX(final World world, final double double2, final double double3, final double double4) {
        super(world, double2, double3, double4, 0.0f, 0.0f, 0.0f);
        this.motionX1 *= 0.3f;
        this.motionY1 = (double)Math.random() * 0.2f + 0.1f;
        this.motionZ1 *= 0.3f;
        this.particleRed = 1.0f;
        this.particleGreen = 1.0f;
        this.particleBlue = 1.0f;
        this.particleTextureIndex = 16;
        this.setSize(0.01f, 0.01f);
        this.particleGravity = 0.06f;
        this.particleMaxAge = (int)(8.0 / (Math.random() * 0.8 + 0.2));
    }
    
    @Override
    public final void renderParticle(final Tessellator tessellator, final double double2, final double double3, final double double4, final double double5, final double double6, final double double7) {
        super.renderParticle(tessellator, double2, double3, double4, double5, double6, double7);
    }
    
    @Override
    public final void onEntityUpdate() {
        this.prevPosX = this.posX;
        this.prevPosY = this.posY;
        this.prevPosZ = this.posZ;
        this.motionY1 -= this.particleGravity;
        this.moveEntity(this.motionX1, this.motionY1, this.motionZ1);
        this.motionX1 *= 0.98f;
        this.motionY1 *= 0.98f;
        this.motionZ1 *= 0.98f;
        if (this.particleMaxAge-- <= 0) {
            this.setEntityDead();
        }
        if (this.onGround) {
            if (Math.random() < 0.5) {
                this.setEntityDead();
            }
            this.motionX1 *= 0.7f;
            this.motionZ1 *= 0.7f;
        }
        final Material blockMaterial;
        if ((blockMaterial = this.worldObj.getBlockMaterial((int)this.posX, (int)this.posY, (int)this.posZ)).getIsLiquid() || blockMaterial.isSolid()) {
            this.setEntityDead();
        }
    }
}
