package net.minecraft.client.physics;

import net.minecraft.game.entity.Entity;
import net.minecraft.client.renderer.Vec3D;

public final class MovingObjectPosition {
    public int typeOfHit;
    public long blockX;
    public long blockY;
    public long blockZ;
    public int sideHit;
    public Vec3D hitVec;
    public Entity entityHit;
    
    public MovingObjectPosition(final long blockX, final long blockY, final long blockZ, final int sideHit, final Vec3D vec3D) {
        this.typeOfHit = 0;
        this.blockX = blockX;
        this.blockY = blockY;
        this.blockZ = blockZ;
        this.sideHit = sideHit;
        this.hitVec = new Vec3D(vec3D.xCoord, vec3D.yCoord, vec3D.zCoord);
    }
    
    public MovingObjectPosition(final Entity entityHit) {
        this.typeOfHit = 1;
        this.entityHit = entityHit;
        this.hitVec = new Vec3D(entityHit.posX, entityHit.posY, entityHit.posZ);
    }
}
