package net.minecraft.client.player;

import net.minecraft.client.GameSettings;

public final class MovementInputFromOptions extends MovementInput {
    private boolean[] movementKeyStates;
    private GameSettings gameSettings;
    private long space = 0;
    
    public MovementInputFromOptions(final GameSettings gameSettings) {
        this.movementKeyStates = new boolean[10];
        this.gameSettings = gameSettings;
    }
    
    @Override
    public final void checkKeyForMovementInput(final int integer, final boolean boolean2) {
        int n = -1;
        if (integer == this.gameSettings.keyBindForward.keyCode) {
            n = 0;
        }
        if (integer == this.gameSettings.keyBindBack.keyCode) {
            n = 1;
        }
        if (integer == this.gameSettings.keyBindLeft.keyCode) {
            n = 2;
        }
        if (integer == this.gameSettings.keyBindRight.keyCode) {
            n = 3;
        }
        if (integer == this.gameSettings.keyBindJump.keyCode) {
            n = 4;
            if(boolean2) {
            	if(System.currentTimeMillis()-space<500) {
            		space = 0;
            		isFlying = !isFlying;
            	} else {
            		space = System.currentTimeMillis();
            	}
            }
        }
        if (n >= 0) {
            this.movementKeyStates[n] = boolean2;
        }
    }
    
    @Override
    public final void resetKeyState() {
        for (int i = 0; i < 10; ++i) {
            this.movementKeyStates[i] = false;
        }
    }
    
    @Override
    public final void updatePlayerMoveState() {
        this.moveStrafe = 0.0f;
        this.moveForward = 0.0f;
        if (this.movementKeyStates[0]) {
            ++this.moveForward;
        }
        if (this.movementKeyStates[1]) {
            --this.moveForward;
        }
        if (this.movementKeyStates[2]) {
            ++this.moveStrafe;
        }
        if (this.movementKeyStates[3]) {
            --this.moveStrafe;
        }
        this.jump = this.movementKeyStates[4];
    }
}
