package net.minecraft.client.player;

import net.minecraft.game.entity.player.EntityPlayer;
import net.minecraft.game.block.Block;
import net.minecraft.game.level.World;
import net.minecraft.client.Minecraft;

public class PlayerController {
    protected final Minecraft mc;
    public boolean isInTestMode;
    
    public PlayerController(final Minecraft minecraft) {
        this.isInTestMode = false;
        this.mc = minecraft;
    }
    
    public void onWorldChange(final World world) {
    }
    
    public void clickBlock(final long integer1, final long integer2, final long integer3) {
        this.sendBlockRemoved(integer1, integer2, integer3);
    }
    
    public boolean sendBlockRemoved(final long integer1, final long integer2, final long integer3) {
        this.mc.effectRenderer.addBlockDestroyEffects(integer1, integer2, integer3);
        final World theWorld = this.mc.theWorld;
        final Block block = Block.blocksList[theWorld.getBlockId(integer1, integer2, integer3)];
        final byte blockMetadata = theWorld.getBlockMetadata(integer1, integer2, integer3);
        final boolean setBlockWithNotify = theWorld.setBlockWithNotify(integer1, integer2, integer3, 0);
        if (block != null && setBlockWithNotify) {
            this.mc.sndManager.playSound(block.stepSound.stepSoundDir(), integer1 + 0.5f, integer2 + 0.5f, integer3 + 0.5f, (block.stepSound.soundVolume + 1.0f) / 2.0f, block.stepSound.soundPitch * 0.8f);
            block.onBlockDestroyedByPlayer(theWorld, integer1, integer2, integer3, blockMetadata);
        }
        return setBlockWithNotify;
    }
    
    public void sendBlockRemoving(final long blockX, final long blockY, final long blockZ, final int integer4) {
    }
    
    public void resetBlockRemoving() {
    }
    
    public void setPartialTime(final double double1) {
    }
    
    public double getBlockReachDistance() {
        return 5.0f;
    }
    
    public void updateController() {
    }
    
    public boolean shouldDrawHUD() {
        return true;
    }
    
    public void blankPlayerFunction(final EntityPlayer entityPlayer) {
    }
}
