package net.minecraft.client.renderer.entity;

import net.minecraft.game.MathHelper;
import net.minecraft.client.renderer.Tessellator;
import org.lwjgl.opengl.GL11;
import net.minecraft.game.entity.other.EntityArrow;
import net.minecraft.game.entity.Entity;

public final class RenderArrow extends Render {
	
    public final void doRender(Entity entity, double f, double f2, double f3, double f4, double f5) {
        EntityArrow arrow = (EntityArrow) entity;
        loadTexture("/item/arrows.png");
        GL11.glPushMatrix();
        GL11.glTranslated(f, f2, f3);
        GL11.glRotated((arrow.prevRotationYaw + ((arrow.rotationYaw - arrow.prevRotationYaw) * f5)) - 90.0f, 0.0f, 1.0f, 0.0f);
        GL11.glRotated(arrow.prevRotationPitch + ((arrow.rotationPitch - arrow.prevRotationPitch) * f5), 0.0f, 0.0f, 1.0f);
        Tessellator dVar = Tessellator.instance;
        GL11.glEnable(2977);
        double f6 = ((double) arrow.arrowShake) - f5;
        if (f6 > 0.0f) {
            GL11.glRotated(f6 * (-MathHelper.sin(3.0f * f6)), 0.0f, 0.0f, 1.0f);
        }
        GL11.glRotated(45.0f, 1.0f, 0.0f, 0.0f);
        GL11.glScaled(0.05625f, 0.05625f, 0.05625f);
        GL11.glTranslated(-4.0f, 0.0f, 0.0f);
        GL11.glNormal3f(0.05625f, 0.0f, 0.0f);
        dVar.startDrawingQuads();
        dVar.addVertexWithUV(-7.0f, -2.0f, -2.0f, 0.0f, 0.15625f);
        dVar.addVertexWithUV(-7.0f, -2.0f, 2.0f, 0.15625f, 0.15625f);
        dVar.addVertexWithUV(-7.0f, 2.0f, 2.0f, 0.15625f, 0.3125f);
        dVar.addVertexWithUV(-7.0f, 2.0f, -2.0f, 0.0f, 0.3125f);
        dVar.draw();
        GL11.glNormal3f(-0.05625f, 0.0f, 0.0f);
        dVar.startDrawingQuads();
        dVar.addVertexWithUV(-7.0f, 2.0f, -2.0f, 0.0f, 0.15625f);
        dVar.addVertexWithUV(-7.0f, 2.0f, 2.0f, 0.15625f, 0.15625f);
        dVar.addVertexWithUV(-7.0f, -2.0f, 2.0f, 0.15625f, 0.3125f);
        dVar.addVertexWithUV(-7.0f, -2.0f, -2.0f, 0.0f, 0.3125f);
        dVar.draw();
        for (int i = 0; i < 4; i++) {
            GL11.glRotated(90.0f, 1.0f, 0.0f, 0.0f);
            GL11.glNormal3f(0.0f, 0.0f, 0.05625f);
            dVar.startDrawingQuads();
            dVar.addVertexWithUV(-8.0f, -2.0f, 0.0f, 0.0f, 0.0f);
            dVar.addVertexWithUV(8.0f, -2.0f, 0.0f, 0.5f, 0.0f);
            dVar.addVertexWithUV(8.0f, 2.0f, 0.0f, 0.5f, 0.15625f);
            dVar.addVertexWithUV(-8.0f, 2.0f, 0.0f, 0.0f, 0.15625f);
            dVar.draw();
        }
        GL11.glDisable(2977);
        GL11.glPopMatrix();
    }
}
