package net.minecraft.game;

public final class MathHelper {
    private static double[] SIN_TABLE;
    
    public static final double sin(final double double1) {
        return MathHelper.SIN_TABLE[(int)(double1 * 10430.378f) & 0xFFFF];
    }
    
    public static final double cos(final double double1) {
        return MathHelper.SIN_TABLE[(int)(double1 * 10430.378f + 16384.0f) & 0xFFFF];
    }
    
    public static final double sqrt_double(final double double1) {
        return (double)Math.sqrt((double)double1);
    }
    
    public static int floor_float(final float double1) {
        final int n = (int)double1;
        if (double1 < n) {
            return n - 1;
        }
        return n;
    }
    
    public static int floor_double(final double double1) {
        final int n = (int)double1;
        if (double1 < n) {
            return n - 1;
        }
        return n;
    }
    
    public static double abs(final double double1) {
        if (double1 >= 0.0f) {
            return double1;
        }
        return -double1;
    }
    
    static {
        MathHelper.SIN_TABLE = new double[65536];
        for (int i = 0; i < 65536; ++i) {
            MathHelper.SIN_TABLE[i] = (double)Math.sin(i * 3.141592653589793 * 2.0 / 65536.0);
        }
    }

	public static long floor_double_long(double d) {
		final long n = (long)d;
        if (d < n) {
            return n - 1;
        }
        return n;
	}
}
