package net.minecraft.game.block;

import java.util.Random;
import net.minecraft.game.level.World;
import net.minecraft.client.physics.AxisAlignedBB;

public final class BlockFarmland extends Block {
    protected BlockFarmland(final int blockID) {
        super(60, Material.ground);
        this.blockIndexInTexture = 87;
        this.setTickOnLoad(true);
        this.setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 0.9375f, 1.0f);
        this.setLightOpacity(255);
    }
    
    @Override
    public final AxisAlignedBB getCollisionBoundingBoxFromPool(final long xCoord, final long yCoord, final long zCoord) {
        return new AxisAlignedBB((double)xCoord, (double)yCoord, (double)zCoord, (double)(xCoord + 1), (double)(yCoord + 1), (double)(zCoord + 1));
    }
    
    @Override
    public final boolean isOpaqueCube() {
        return false;
    }
    
    @Override
    public final boolean renderAsNormalBlock() {
        return false;
    }
    
    @Override
    public final int getBlockTextureFromSideAndMetadata(final int integer1, final int integer2) {
        if (integer1 == 1 && integer2 > 0) {
            return this.blockIndexInTexture - 1;
        }
        if (integer1 == 1) {
            return this.blockIndexInTexture;
        }
        return 2;
    }
    
    @Override
    public final void updateTick(final World world, final long xCoord, final long yCoord, final long zCoord, final Random random) {
        boolean b;
        boolean b2 = true;
        if (random.nextInt(5) == 0) {
        	long i4 = xCoord - 4;
            loop0:
            while (true) {
                if (i4 > xCoord + 4) {
                    b = false;
                    break;
                }
                for (long i5 = yCoord; i5 <= yCoord + 1; i5++) {
                    for (long i6 = zCoord - 4; i6 <= zCoord + 4; i6++) {
                        if (world.getBlockMaterial(i4, i5, i6) == Material.water) {
                            b = true;
                            break loop0;
                        }
                    }
                }
                i4++;
            }
            if (b) {
                world.setBlockMetadataWithNotify(xCoord, yCoord, zCoord, 7);
                return;
            }
            byte e = world.getBlockMetadata(xCoord, yCoord, zCoord);
            if (e > 0) {
                world.setBlockMetadataWithNotify(xCoord, yCoord, zCoord, e - 1);
                return;
            }
            long i7 = xCoord;
            loop3:
            while (true) {
                if (i7 > xCoord) {
                    b2 = false;
                    break;
                }
                for (long i8 = zCoord; i8 <= zCoord; i8++) {
                    if (world.getBlockId(i7, yCoord + 1, i8) == Block.crops.blockID) {
                        break loop3;
                    }
                }
                i7++;
            }
            if (!b2) {
                world.setBlockWithNotify(xCoord, yCoord, zCoord, Block.dirt.blockID);
            }
        }
    }
    
    @Override
    public final void onEntityWalking(final World world, final int integer2, final int integer3, final int integer4) {
        if (world.random.nextInt(4) == 0) {
            world.setBlockWithNotify(integer2, integer3, integer4, Block.dirt.blockID);
        }
    }
    
    @Override
    public final void onNeighborBlockChange(final World world, final long xCoord, final long yCoord, final long zCoord, final int blockID) {
        super.onNeighborBlockChange(world, xCoord, yCoord, zCoord, blockID);
        if (world.getBlockMaterial(xCoord, yCoord + 1, zCoord).isSolid()) {
            world.setBlockWithNotify(xCoord, yCoord, zCoord, Block.dirt.blockID);
        }
    }
    
    @Override
    public final int idDropped(final int integer, final Random random) {
        return Block.dirt.idDropped(0, random);
    }
}
