package net.minecraft.game.block;

import net.minecraft.client.physics.AxisAlignedBB;
import net.minecraft.game.level.World;
import java.util.Random;

public final class BlockFluidFlowing extends BlockFluid {
    private int stillId1;
    private int movingId1;
    private Random rand;
    private int[] liquidIntArray;
    
    protected BlockFluidFlowing(final int blockID, final Material material) {
        super(blockID, material);
        this.rand = new Random();
        this.liquidIntArray = new int[] { 0, 1, 2, 3 };
        this.blockIndexInTexture = 14;
        if (material == Material.lava) {
            this.blockIndexInTexture = 30;
        }
        Block.isBlockContainer[blockID] = true;
        this.movingId1 = blockID;
        this.stillId1 = blockID + 1;
        this.setBlockBounds(0.01f, -0.09f, 0.01f, 1.01f, 0.90999997f, 1.01f);
        this.setTickOnLoad(true);
    }
    
    @Override
    public final void onBlockAdded(final World world, final long xCoord, final long yCoord, final long zCoord) {
        world.scheduleBlockUpdate(xCoord, yCoord, zCoord, this.movingId1);
    }
    
    @Override
    public final void updateTick(final World world, final long xCoord, final long yCoord, final long zCoord, final Random random) {
        this.update(world, xCoord, yCoord, zCoord, 0);
    }
    
    @Override
    public final boolean update(final World world, long xCoord, final long yCoord, final long zCoord, int integer5) {
        integer5 = 0;
        final boolean b;
        if ((b = (this.canFlow(world, xCoord - 1, yCoord, zCoord) || this.canFlow(world, xCoord + 1, yCoord, zCoord) || this.canFlow(world, xCoord, yCoord, zCoord - 1) || this.canFlow(world, xCoord, yCoord, zCoord + 1))) && world.getBlockMaterial(xCoord, yCoord - 1, zCoord) == this.blockMaterial && (integer5 = world.unknownFluidMethod(xCoord, yCoord - 1, zCoord, this.movingId1, this.stillId1)) == 1) {
            int i;
            if ((i = world.fluidFlowCheck(xCoord, yCoord, zCoord, this.movingId1, this.stillId1)) == -9999) {
                return false;
            }
            if (i < 0) {
                return false;
            }
            final int integer6 = i % 1024;
            final int integer7 = (i >>= 10) % 1024;
            xCoord = (i >>= 10) % 1024;
            world.setBlockWithNotify(integer6, xCoord, integer7, 0);
            return false;
        }
        else {
            integer5 = (this.liquidSpread2(world, xCoord, yCoord, zCoord, xCoord, yCoord - 1, zCoord) ? 1 : 0);
            for (int i = 0; i < 4; ++i) {
                final int integer6 = this.rand.nextInt(4 - i) + i;
                final int integer7 = this.liquidIntArray[i];
                this.liquidIntArray[i] = this.liquidIntArray[integer6];
                this.liquidIntArray[integer6] = integer7;
                if (this.liquidIntArray[i] == 0 && integer5 == 0) {
                    integer5 = (this.liquidSpread2(world, xCoord, yCoord, zCoord, xCoord - 1, yCoord, zCoord) ? 1 : 0);
                }
                if (this.liquidIntArray[i] == 1 && integer5 == 0) {
                    integer5 = (this.liquidSpread2(world, xCoord, yCoord, zCoord, xCoord + 1, yCoord, zCoord) ? 1 : 0);
                }
                if (this.liquidIntArray[i] == 2 && integer5 == 0) {
                    integer5 = (this.liquidSpread2(world, xCoord, yCoord, zCoord, xCoord, yCoord, zCoord - 1) ? 1 : 0);
                }
                if (this.liquidIntArray[i] == 3 && integer5 == 0) {
                    integer5 = (this.liquidSpread2(world, xCoord, yCoord, zCoord, xCoord, yCoord, zCoord + 1) ? 1 : 0);
                }
            }
            if (integer5 == 0 && b) {
                if (this.rand.nextInt(3) == 0) {
                    if (this.rand.nextInt(3) == 0) {
                        integer5 = 0;
                        for (int i = 0; i < 4; ++i) {
                            final int integer6 = this.rand.nextInt(4 - i) + i;
                            final int integer7 = this.liquidIntArray[i];
                            this.liquidIntArray[i] = this.liquidIntArray[integer6];
                            this.liquidIntArray[integer6] = integer7;
                            if (this.liquidIntArray[i] == 0 && integer5 == 0) {
                                integer5 = (this.liquidSpread(world, xCoord, yCoord, zCoord, xCoord - 1, yCoord, zCoord) ? 1 : 0);
                            }
                            if (this.liquidIntArray[i] == 1 && integer5 == 0) {
                                integer5 = (this.liquidSpread(world, xCoord, yCoord, zCoord, xCoord + 1, yCoord, zCoord) ? 1 : 0);
                            }
                            if (this.liquidIntArray[i] == 2 && integer5 == 0) {
                                integer5 = (this.liquidSpread(world, xCoord, yCoord, zCoord, xCoord, yCoord, zCoord - 1) ? 1 : 0);
                            }
                            if (this.liquidIntArray[i] == 3 && integer5 == 0) {
                                integer5 = (this.liquidSpread(world, xCoord, yCoord, zCoord, xCoord, yCoord, zCoord + 1) ? 1 : 0);
                            }
                        }
                    }
                    else if (this.blockMaterial == Material.lava) {
                        world.setBlockWithNotify(xCoord, yCoord, zCoord, Block.stone.blockID);
                    }
                    else {
                        world.setBlockWithNotify(xCoord, yCoord, zCoord, 0);
                    }
                }
                return false;
            }
            if (this.blockMaterial == Material.water) {
                integer5 = ((integer5 = ((integer5 = ((integer5 |= (extinguishFireLava(world, xCoord - 1, yCoord, zCoord) ? 1 : 0)) | (extinguishFireLava(world, xCoord + 1, yCoord, zCoord) ? 1 : 0))) | (extinguishFireLava(world, xCoord, yCoord, zCoord - 1) ? 1 : 0))) | (extinguishFireLava(world, xCoord, yCoord, zCoord + 1) ? 1 : 0));
            }
            if (this.blockMaterial == Material.lava) {
                integer5 = ((integer5 = ((integer5 = ((integer5 |= (flow(world, xCoord - 1, yCoord, zCoord) ? 1 : 0)) | (flow(world, xCoord + 1, yCoord, zCoord) ? 1 : 0))) | (flow(world, xCoord, yCoord, zCoord - 1) ? 1 : 0))) | (flow(world, xCoord, yCoord, zCoord + 1) ? 1 : 0));
            }
            if (integer5 == 0) {
                world.setTileNoUpdate(xCoord, yCoord, zCoord, this.stillId1);
            }
            else {
                world.scheduleBlockUpdate(xCoord, yCoord, zCoord, this.movingId1);
            }
            return integer5 != 0;
        }
    }
    
    private boolean liquidSpread(final World world, final long integer2, final long integer3, final long integer4, final long integer5, final long integer6, final long integer7) {
        if (this.canFlow(world, integer5, integer6, integer7)) {
            world.setBlockWithNotify(integer5, integer6, integer7, this.blockID);
            world.scheduleBlockUpdate(integer5, integer6, integer7, this.blockID);
            return true;
        }
        return false;
    }
    
    private boolean liquidSpread2(final World world, long integer2, long integer3, long integer4, final long integer5, final long integer6, final long integer7) {
        if (this.canFlow(world, integer5, integer6, integer7)) {
            if ((integer2 = world.fluidFlowCheck(integer2, integer3, integer4, this.movingId1, this.stillId1)) != -9999) {
                if (integer2 < 0) {
                    return false;
                }
                integer3 = integer2 % 1024;
                integer4 = (integer2 >>= 10) % 1024;
	                if (((integer2 = (integer2 >>= 10) % 1024) > integer6 || !this.canFlow(world, integer5, integer6 - 1, integer7)) && integer2 <= integer6 && integer3 != 0 && integer3 != world.width - 1 && integer4 != 0 && integer4 != world.length - 1) {
	                    return false;
                }
                world.setBlockWithNotify(integer3, integer2, integer4, 0);
            }
            world.setBlockWithNotify(integer5, integer6, integer7, this.blockID);
            world.scheduleBlockUpdate(integer5, integer6, integer7, this.blockID);
            return true;
        }
        return false;
    }
    
    @Override
    public final boolean shouldSideBeRendered(final World world, final long xCoord, final long yCoord, final long zCoord, final int integer5) {
        final int blockId;
//         xCoord >= 0 && yCoord >= 0 && zCoord >= 0 && xCoord < world.width && zCoord < world.length && (blockId = world.getBlockId(xCoord, yCoord, zCoord)) != this.movingId1 && blockId != this.stillId1 && ((integer5 == 1 && (world.getBlockId(xCoord - 1, yCoord, zCoord) == 0 || world.getBlockId(xCoord + 1, yCoord, zCoord) == 0 || world.getBlockId(xCoord, yCoord, zCoord - 1) == 0 || world.getBlockId(xCoord, yCoord, zCoord + 1) == 0)) || super.shouldSideBeRendered(world, xCoord, yCoord, zCoord, integer5));
        return (blockId = world.getBlockId(xCoord, yCoord, zCoord)) != this.movingId1 && blockId != this.stillId1 && ((integer5 == 1 && (world.getBlockId(xCoord - 1, yCoord, zCoord) == 0 || world.getBlockId(xCoord + 1, yCoord, zCoord) == 0 || world.getBlockId(xCoord, yCoord, zCoord - 1) == 0 || world.getBlockId(xCoord, yCoord, zCoord + 1) == 0)) || super.shouldSideBeRendered(world, xCoord, yCoord, zCoord, integer5));
    }
    
    @Override
    public final boolean isCollidable() {
        return false;
    }
    
    @Override
    public final AxisAlignedBB getCollisionBoundingBoxFromPool(final long xCoord, final long yCoord, final long zCoord) {
        return null;
    }
    
    @Override
    public final boolean isOpaqueCube() {
        return false;
    }
    
    @Override
    public final void onNeighborBlockChange(final World world, final long xCoord, final long yCoord, final long zCoord, final int blockID) {
    }
    
    @Override
    public final int tickRate() {
        if (this.blockMaterial == Material.lava) {
            return 25;
        }
        return 5;
    }
    
    @Override
    public final int quantityDropped(final Random random) {
        return 0;
    }
    
    @Override
    public final int getRenderBlockPass() {
        if (this.blockMaterial == Material.water) {
            return 1;
        }
        return 0;
    }
    
    private static boolean extinguishFireLava(final World world, final long integer2, final long integer3, final long integer4) {
        if (world.getBlockId(integer2, integer3, integer4) == Block.fire.blockID) {
            world.setBlockWithNotify(integer2, integer3, integer4, 0);
            return true;
        }
        if (world.getBlockId(integer2, integer3, integer4) == Block.lavaMoving.blockID || world.getBlockId(integer2, integer3, integer4) == Block.lavaStill.blockID) {
            world.setBlockWithNotify(integer2, integer3, integer4, Block.stone.blockID);
            return true;
        }
        return false;
    }
    
    private static boolean flow(final World g, final long integer2, final long integer3, final long integer4) {
        if (Block.fire.getChanceOfNeighborsEncouragingFire(g.getBlockId(integer2, integer3, integer4))) {
            Block.fire.fireSpread(g, integer2, integer3, integer4);
            return true;
        }
        return false;
    }
}
