package net.minecraft.game.block;

import java.util.Random;
import net.minecraft.game.level.World;

public final class BlockFluidStill extends BlockFluid {
    protected BlockFluidStill(final int blockID, final Material material) {
        super(blockID, material);
        this.movingId = blockID - 1;
        this.stillId = blockID;
        this.setTickOnLoad(false);
    }
    
    @Override
    public final void updateTick(final World world, final long xCoord, final long yCoord, final long zCoord, final Random random) {
    }
    
    @Override
    public final void onNeighborBlockChange(final World world, final long xCoord, final long yCoord, final long zCoord, final int blockID) {
        int n = 0;
        if (this.canFlow(world, xCoord, yCoord - 1, zCoord)) {
            n = 1;
        }
        if (n == 0 && this.canFlow(world, xCoord - 1, yCoord, zCoord)) {
            n = 1;
        }
        if (n == 0 && this.canFlow(world, xCoord + 1, yCoord, zCoord)) {
            n = 1;
        }
        if (n == 0 && this.canFlow(world, xCoord, yCoord, zCoord - 1)) {
            n = 1;
        }
        if (n == 0 && this.canFlow(world, xCoord, yCoord, zCoord + 1)) {
            n = 1;
        }
        if (blockID != 0) {
            final Material blockMaterial = Block.blocksList[blockID].blockMaterial;
            if ((this.blockMaterial == Material.water && blockMaterial == Material.lava) || (blockMaterial == Material.water && this.blockMaterial == Material.lava)) {
                world.setBlockWithNotify(xCoord, yCoord, zCoord, Block.stone.blockID);
                return;
            }
        }
        if (Block.fire.getChanceOfNeighborsEncouragingFire(blockID)) {
            n = 1;
        }
        if (n != 0) {
            world.setTileNoUpdate(xCoord, yCoord, zCoord, this.movingId);
            world.scheduleBlockUpdate(xCoord, yCoord, zCoord, this.movingId);
        }
    }
}
