package net.minecraft.game.block;

import java.util.Random;
import net.minecraft.game.level.World;

public final class BlockGrass extends Block {
    protected BlockGrass(final int blockID) {
        super(2, Material.ground);
        this.blockIndexInTexture = 3;
        this.setTickOnLoad(true);
    }
    
    @Override
    public final int getBlockTextureFromSide(final int blockSide) {
        if (blockSide == 1) {
            return 0;
        }
        if (blockSide == 0) {
            return 2;
        }
        return 3;
    }
    
    @Override
    public final void updateTick(final World world, long xCoord, long yCoord, long zCoord, final Random random) {
        if (world.getBlockLightValue(xCoord, yCoord + 1, zCoord) >= 4 || !world.getBlockMaterial(xCoord, yCoord + 1, zCoord).getCanBlockGrass()) {
            if (world.getBlockLightValue(xCoord, yCoord + 1, zCoord) >= 9) {
                xCoord = xCoord + random.nextInt(3) - 1;
                yCoord = yCoord + random.nextInt(5) - 3;
                zCoord = zCoord + random.nextInt(3) - 1;
                if (world.getBlockId(xCoord, yCoord, zCoord) == Block.dirt.blockID && world.getBlockLightValue(xCoord, yCoord + 1, zCoord) >= 4 && !world.getBlockMaterial(xCoord, yCoord + 1, zCoord).getCanBlockGrass()) {
                    world.setBlockWithNotify(xCoord, yCoord, zCoord, Block.grass.blockID);
                }
            }
            return;
        }
        if (random.nextInt(4) != 0) {
            return;
        }
        world.setBlockWithNotify(xCoord, yCoord, zCoord, Block.dirt.blockID);
    }
    
    @Override
    public final int idDropped(final int integer, final Random random) {
        return Block.dirt.idDropped(0, random);
    }
}
