package net.minecraft.game.block;

import net.minecraft.game.level.World;
import java.util.Random;

public class BlockSand extends Block {
    public BlockSand(final int blockID, final int textureSlot) {
        super(blockID, textureSlot, Material.sand);
        new Random();
    }
    
    @Override
    public final void onBlockAdded(final World world, final long xCoord, final long yCoord, final long zCoord) {
        this.scheduleBlockUpdate(world, xCoord, yCoord, zCoord);
    }
    
    @Override
    public final void onNeighborBlockChange(final World world, final long xCoord, final long yCoord, final long zCoord, final int blockID) {
        this.scheduleBlockUpdate(world, xCoord, yCoord, zCoord);
    }
    
    private void scheduleBlockUpdate(final World world, final long xCoord, final long yCoord, final long zCoord) {
        long integer5 = yCoord;
        int n;
        Material blockMaterial;
        while (((n = world.getBlockId(xCoord, integer5 - 1, zCoord)) == 0 || n == Block.fire.blockID || (blockMaterial = Block.blocksList[n].blockMaterial) == Material.water || blockMaterial == Material.lava) && integer5 >= 0) {
            --integer5;
            if (world.getBlockId(xCoord, integer5, zCoord) == Block.fire.blockID) {
                world.setTileNoNeighborChange(xCoord, integer5, zCoord, 0);
            }
        }
        if (integer5 < 0) {
            world.setTileNoUpdate(xCoord, yCoord, zCoord, 0);
        }
        if (integer5 != yCoord) {
            if ((n = world.getBlockId(xCoord, integer5, zCoord)) > 0 && Block.blocksList[n].blockMaterial != Material.air) {
                world.setTileNoUpdate(xCoord, integer5, zCoord, 0);
            }
            world.swap(xCoord, yCoord, zCoord, xCoord, integer5, zCoord);
        }
    }
}
