package net.minecraft.game.block;

import net.minecraft.game.level.World;

public final class BlockSponge extends Block {
    protected BlockSponge(final int blockID) {
        super(19, Material.sponge);
        this.blockIndexInTexture = 48;
    }
    
    @Override
    public final void onBlockAdded(final World world, final long xCoord, final long yCoord, final long zCoord) {
        for (long i = xCoord - 2; i <= xCoord + 2; ++i) {
            for (long j = yCoord - 2; j <= yCoord + 2; ++j) {
                for (long k = zCoord - 2; k <= zCoord + 2; ++k) {
                    if (world.isWater(i, j, k)) {
                        world.setTileNoNeighborChange(i, j, k, 0);
                    }
                }
            }
        }
    }
    
    @Override
    public final void onBlockRemoval(final World world, final long xCoord, final long yCoord, final long zCoord) {
        for (long i = xCoord - 2; i <= xCoord + 2; ++i) {
            for (long j = yCoord - 2; j <= yCoord + 2; ++j) {
                for (long k = zCoord - 2; k <= zCoord + 2; ++k) {
                    world.notifyBlocksOfNeighborChange(i, j, k, world.getBlockId(i, j, k));
                }
            }
        }
    }
}
