package net.minecraft.game.block;

import net.minecraft.game.entity.player.EntityPlayer;
import net.minecraft.game.level.World;

public final class BlockWorkbench extends Block {
    protected BlockWorkbench(final int blockID) {
        super(58, Material.wood);
        this.blockIndexInTexture = 59;
    }
    
    @Override
    public final int getBlockTextureFromSide(final int blockSide) {
        if (blockSide == 1) {
            return this.blockIndexInTexture - 16;
        }
        if (blockSide == 0) {
            return Block.planks.getBlockTextureFromSide(0);
        }
        if (blockSide == 2 || blockSide == 4) {
            return this.blockIndexInTexture + 1;
        }
        return this.blockIndexInTexture;
    }
    
    @Override
    public final boolean blockActivated(final World world, final long xCoord, final long yCoord, final long zCoord, final EntityPlayer player) {
        player.displayWorkbenchGUI();
        return true;
    }
}
