package net.minecraft.game.entity.animal;

import com.nbt.NBTTagCompound;
import net.minecraft.game.block.Block;
import net.minecraft.game.level.World;
import net.minecraft.game.entity.EntityCreature;

public abstract class EntityAnimals extends EntityCreature {
    public EntityAnimals(final World world) {
        super(world);
    }
    
    @Override
    protected final double getBlockPathWeight(final int integer1, final int integer2, final int integer3) {
        if (this.worldObj.getBlockId(integer1, integer2 - 1, integer3) == Block.grass.blockID) {
            return 10.0f;
        }
        return this.worldObj.getLightBrightness(integer1, integer2, integer3) - 0.5f;
    }
    
    @Override
    protected void writeEntityToNBT(final NBTTagCompound nbtTagCompound) {
        super.writeEntityToNBT(nbtTagCompound);
    }
    
    @Override
    protected void readEntityFromNBT(final NBTTagCompound nbtTagCompound) {
        super.readEntityFromNBT(nbtTagCompound);
    }
    
    @Override
    public final boolean getCanSpawnHere(final double double1, final double double2, final double double3) {
        return this.worldObj.getBlockLightValue((int)double1, (int)double2, (int)double3) > 8 && super.getCanSpawnHere(double1, double2, double3);
    }
}
