package net.minecraft.game.item;

import net.minecraft.game.entity.Entity;
import net.minecraft.game.entity.other.EntityItem;
import net.minecraft.game.block.Block;
import net.minecraft.game.level.World;

public final class ItemHoe extends Item {
    public ItemHoe(final int itemID, final int damage) {
        super(itemID);
        this.maxStackSize = 1;
        this.maxDamage = 32 << damage;
    }
    
    @Override
    public final boolean onItemUse(final ItemStack itemStack, final World world, final long integer3, final long integer4, final long integer5, int integer6) {
        integer6 = world.getBlockId(integer3, integer4, integer5);
        if ((!world.getBlockMaterial(integer3, integer4 + 1, integer5).isSolid() && integer6 == Block.grass.blockID) || integer6 == Block.dirt.blockID) {
            final Block tilledField = Block.tilledField;
            world.playSoundAtPlayer(integer3 + 0.5f, integer4 + 0.5f, integer5 + 0.5f, tilledField.stepSound.stepSoundDir2(), (tilledField.stepSound.soundVolume + 1.0f) / 2.0f, tilledField.stepSound.soundPitch * 0.8f);
            world.setBlockWithNotify(integer3, integer4, integer5, tilledField.blockID);
            itemStack.damageItem(1);
            if (world.random.nextInt(8) == 0 && integer6 == Block.grass.blockID) {
                for (int i = 0; i <= 0; ++i) {
                    final EntityItem entity;
                    (entity = new EntityItem(world, integer3 + (world.random.nextDouble() * 0.7f + 0.15f), integer4 + 1.2f, integer5 + (world.random.nextDouble() * 0.7f + 0.15f), new ItemStack(Item.seeds))).delayBeforeCanPickup = 10;
                    world.entityJoinedWorld(entity);
                }
            }
            return true;
        }
        return false;
    }
}
