package net.minecraft.game.item;

import net.minecraft.game.block.Block;

public final class ItemSword extends Item {
    private int weaponDamage;
    
    public ItemSword(final int itemID, final int damage) {
        super(itemID);
        this.maxStackSize = 1;
        this.maxDamage = 32 << damage;
        this.weaponDamage = 4 + (damage << 1);
    }
    
    @Override
    public final double getStrVsBlock(final Block block) {
        return 1.5f;
    }
    
    @Override
    public final void hitEntity(final ItemStack itemStack) {
        itemStack.damageItem(1);
    }
    
    @Override
    public final void onBlockDestroyed(final ItemStack itemStack) {
        itemStack.damageItem(2);
    }
    
    @Override
    public final int getDamageVsEntity() {
        return this.weaponDamage;
    }
}
