package net.minecraft.game.level;

public class ChunkCoord {
	public final long x;
	public final long y;
	public final long z;
	
	private final int hash;

	public ChunkCoord(long x, long y, long z) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.hash = (int) ((x & 0xFFF) << 20 | (y & 0xFF) << 12 | (z & 0xFFF));
	}

	public int hashCode() {
		return hash;
	}

	public boolean equals(Object obj) {
		if (obj == null || !(obj instanceof ChunkCoord))
			return false;
		ChunkCoord cc = (ChunkCoord) obj;
		return cc.x == x && cc.y == y && cc.z == z;
	}
}
