package net.minecraft.game.level.generator.noise;

import java.util.Random;

public class OctaveNoiseInfdev0227
{
	public OctaveNoiseInfdev0227(Random random, int octaves)
	{
		this.octaves = octaves;
		perlin = new PerlinNoiseInfdev0227[octaves];

		for(int count = 0; count < octaves; count++)
		{
			perlin[count] = new PerlinNoiseInfdev0227(random);
		}

	}

	public double compute(double x, double z)
	{
		double result = 0.0D;
		double unknown0 = 1.0D;

		for(int count = 0; count < octaves; count++)
		{
			result += perlin[count].compute(x / unknown0, z / unknown0) * unknown0;

			unknown0 *= 2.0D;
		}

		return result;
	}

	public double compute(double x, double y, double z)
	{
		double result = 0.0D;
		double unknown0 = 1.0D;

		for(int count = 0; count < octaves; count++)
		{
			result += perlin[count].compute(x / unknown0, y / unknown0, z / unknown0) * unknown0;

			unknown0 *= 2.0D;
		}

		return result;
	}

	private PerlinNoiseInfdev0227[] perlin;
	private int octaves;
}
